From 03e94e0c7cdc6dcc7ef1196f40f5f12a7820661d Mon Sep 17 00:00:00 2001
From: Michael Haubenwallner <michael.haubenwallner@ssi-schaefer.com>
Date: Wed, 22 May 2019 15:26:53 +0200
Subject: [PATCH 21/21] fix format string mixing 32bit and 64bit datatypes

CORBA::Long datatype is 32bit, but C datatype long may be 64bit.
For CORBA::Long better always use C datatype int (when it has 32bit).
---
 idl/codegen-wsdl.cc  |  8 ++++----
 idl/codegen.cc       | 15 ---------------
 idl/codegen.h        |  8 --------
 include/mico/types.h | 12 ++++++------
 orb/uni_fromuni.cc   |  2 +-
 orb/uni_touni.cc     |  2 +-
 orb/uni_types.h      |  8 ++++----
 7 files changed, 16 insertions(+), 39 deletions(-)

diff --git a/idl/codegen-wsdl.cc b/idl/codegen-wsdl.cc
index e2847be..0ddef32 100644
--- a/idl/codegen-wsdl.cc
+++ b/idl/codegen-wsdl.cc
@@ -934,7 +934,7 @@ CodeGenWSDL::Identifier CodeGenWSDL::getTypename(CORBA::IDLType_ptr type, bool p
  		{
  			CORBA::StringDef_ptr s =
  				CORBA::StringDef::_narrow(type);
- 			sprintf(&buf[0], "%sCORBA.string_%lu",
+			sprintf(&buf[0], "%sCORBA.string_%u",
 				prefix?"tns:":"",
  				s->bound());
  			return &buf[0];
@@ -945,7 +945,7 @@ CodeGenWSDL::Identifier CodeGenWSDL::getTypename(CORBA::IDLType_ptr type, bool p
  		{
  			CORBA::WstringDef_ptr s =
  				CORBA::WstringDef::_narrow(type);
-	 		sprintf(&buf[0], "%sCORBA.string_%lu",
+			sprintf(&buf[0], "%sCORBA.string_%u",
 				prefix?"tns:":"",
 	 			s->bound());
 	 		return &buf[0];
@@ -956,7 +956,7 @@ CodeGenWSDL::Identifier CodeGenWSDL::getTypename(CORBA::IDLType_ptr type, bool p
 		{
 			CORBA::SequenceDef_ptr s =
 				CORBA::SequenceDef::_narrow(type);
-			sprintf(&buf[0], "%sCORBA.sequence_%lu_",
+			sprintf(&buf[0], "%sCORBA.sequence_%u_",
 				prefix?"tns:":"",
 				s->bound());
 			return &buf[0] +  getTypename(s->element_type_def(), false);
@@ -967,7 +967,7 @@ CodeGenWSDL::Identifier CodeGenWSDL::getTypename(CORBA::IDLType_ptr type, bool p
 		{
 			CORBA::ArrayDef_ptr a =
 				CORBA::ArrayDef::_narrow(type);
-			sprintf(&buf[0], "%sCORBA.array_%lu_",
+			sprintf(&buf[0], "%sCORBA.array_%u_",
 				prefix?"tns:":"",
 				a->length());
 			return &buf[0] + getTypename(a->element_type_def(), false);
diff --git a/idl/codegen.cc b/idl/codegen.cc
index fb4ff7d..12cba95 100644
--- a/idl/codegen.cc
+++ b/idl/codegen.cc
@@ -124,14 +124,6 @@ OutputStream &OutputStream::operator<<( const CORBA::WChar *s )
   return *this;
 }
 
-#if SIZEOF_LONG == 4
-OutputStream &OutputStream::operator<<( int i )
-{
-  checkBofL();
-  *_ostr << i;
-  return *this;
-}
-#endif
 
 
 OutputStream &OutputStream::operator<<( CORBA::LongDouble ld )
@@ -605,13 +597,6 @@ Output &Output::operator<<( const CORBA::WChar *s )
   return *this;
 }
 
-#if SIZEOF_LONG == 4
-Output &Output::operator<<( int i )
-{
-  (*_streams[ _current_stream ]) << i;
-  return *this;
-}
-#endif
 
 Output &Output::operator<<( CORBA::LongDouble ld )
 {
diff --git a/idl/codegen.h b/idl/codegen.h
index 86885e2..732eb0a 100644
--- a/idl/codegen.h
+++ b/idl/codegen.h
@@ -80,10 +80,6 @@ class OutputStream
   OutputStream &operator<<( const char *s );
   OutputStream &operator<<( const std::string &str );
   OutputStream &operator<<( const CORBA::WChar *s );
-#if SIZEOF_LONG == 4
-  // on 64 bit systems CORBA::Long is int
-  OutputStream &operator<<( int i );
-#endif
   OutputStream &operator<<( CORBA::LongDouble ld );
   OutputStream &operator<<( CORBA::Float f );
   OutputStream &operator<<( CORBA::Double d );
@@ -127,10 +123,6 @@ class Output
   Output &operator<<( const char *s );
   Output &operator<<( const std::string &str );
   Output &operator<<( const CORBA::WChar *s );
-#if SIZEOF_LONG == 4
-  // on 64 bit systems CORBA::Long is int
-  Output &operator<<( int i );
-#endif
   Output &operator<<( CORBA::LongDouble ld );
   Output &operator<<( CORBA::Float f );
   Output &operator<<( CORBA::Double d );
diff --git a/include/mico/types.h b/include/mico/types.h
index 36c5924..f2c7810 100644
--- a/include/mico/types.h
+++ b/include/mico/types.h
@@ -31,10 +31,10 @@ typedef short MICO_Short;
 #error "sizeof(short) != 2"
 #endif
 
-#if SIZEOF_LONG == 4
-typedef long MICO_Long;
-#elif SIZEOF_INT == 4
+#if SIZEOF_INT == 4
 typedef int MICO_Long;
+#elif SIZEOF_LONG == 4
+typedef long MICO_Long;
 #else
 #error "sizeof(long) != 4 and sizeof(int) != 4"
 #endif
@@ -55,10 +55,10 @@ typedef unsigned short MICO_UShort;
 #error "sizeof(unsigned short) != 2"
 #endif
 
-#if SIZEOF_UNSIGNED_LONG == 4
-typedef unsigned long MICO_ULong;
-#elif SIZEOF_UNSIGNED_INT == 4
+#if SIZEOF_UNSIGNED_INT == 4
 typedef unsigned int MICO_ULong;
+#elif SIZEOF_UNSIGNED_LONG == 4
+typedef unsigned long MICO_ULong;
 #else
 #error "sizeof(unsigned long) != 4 and sizeof(unsigned int) != 4"
 #endif
diff --git a/orb/uni_fromuni.cc b/orb/uni_fromuni.cc
index fdcebb2..cb9e22b 100644
--- a/orb/uni_fromuni.cc
+++ b/orb/uni_fromuni.cc
@@ -1073,7 +1073,7 @@ cont:         dest[di++] = ';';
             }
             else
             {
-              sprintf(buffer, "&#%lu;", character);
+              sprintf(buffer, "&#%u;", character);
               strcpy(&dest[di], buffer);
               di += strlen(buffer);
             }
diff --git a/orb/uni_touni.cc b/orb/uni_touni.cc
index f04f161..8130286 100644
--- a/orb/uni_touni.cc
+++ b/orb/uni_touni.cc
@@ -838,7 +838,7 @@ static uni_ulong ScanHTML(register const char *src, uni_uword *length)
     if(src[i] != ';') return(0l);  /* no terminating ';'-sign */
 
     buffer[mid]='\0';
-    sscanf(buffer,"%lu", &upper);
+    sscanf(buffer,"%u", &upper);
     *length = i+1;
     return(upper);
   }
diff --git a/orb/uni_types.h b/orb/uni_types.h
index ed94c50..0dcbb0c 100644
--- a/orb/uni_types.h
+++ b/orb/uni_types.h
@@ -55,12 +55,12 @@ typedef unsigned char uni_ubyte;
 typedef unsigned char uni_uchar;
 typedef unsigned short uni_ushort;
 
-#if SIZEOF_LONG == 4
-typedef long uni_slong;
-typedef unsigned long uni_ulong;
-#elif SIZEOF_INT == 4
+#if SIZEOF_INT == 4
 typedef int uni_slong;
 typedef unsigned int uni_ulong;
+#elif SIZEOF_LONG == 4
+typedef long uni_slong;
+typedef unsigned long uni_ulong;
 #else
 #error "no builtin 4 byte interger type"
 #endif
